Index: /LMDZ5/branches/testing/libf/phylmd/readaerosol_optic.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/readaerosol_optic.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/readaerosol_optic.F90	(revision 2408)
@@ -68,6 +68,6 @@
   REAL, DIMENSION(klon,klev)   :: ssacu_pi
   REAL, DIMENSION(klon,klev)   :: pdel
-  REAL, DIMENSION(klon,klev,naero_spc) :: m_allaer
-  REAL, DIMENSION(klon,klev,naero_spc) :: m_allaer_pi !RAF  
+  REAL, DIMENSION(klon,klev,naero_tot) :: m_allaer
+  REAL, DIMENSION(klon,klev,naero_tot) :: m_allaer_pi !RAF  
 !  REAL, DIMENSION(klon,naero_tot)      :: fractnat_allaer !RAF delete??
 
@@ -156,24 +156,28 @@
   m_allaer(:,:,id_AIBCM_phy)  = bcins(:,:)        ! AIBCM
   m_allaer(:,:,id_AIPOMM_phy) = pomins(:,:)       ! AIPOMM
+  m_allaer(:,:,id_ASNO3M_phy) = 0.0
+  m_allaer(:,:,id_CSNO3M_phy) = 0.0
+  m_allaer(:,:,id_CINO3M_phy) = 0.0
 
 !RAF
-  m_allaer_pi(:,:,1)  = bcsol_pi(:,:)        ! ASBCM pre-ind
-  m_allaer_pi(:,:,2)  = pomsol_pi(:,:)       ! ASPOMM pre-ind
-  m_allaer_pi(:,:,3)  = sulfate_pi(:,:)      ! ASSO4M (= SO4) pre-ind
-  m_allaer_pi(:,:,4)  = 0.                ! CSSO4M pre-ind
-  m_allaer_pi(:,:,5)  = sssupco_pi(:,:)      ! SSSSM pre-ind
-  m_allaer_pi(:,:,6)  = sscoarse_pi(:,:)     ! CSSSM pre-ind
-  m_allaer_pi(:,:,7)  = ssacu_pi(:,:)        ! ASSSM pre-ind
-  m_allaer_pi(:,:,8)  = cidust_pi(:,:)       ! CIDUSTM pre-ind
-  m_allaer_pi(:,:,9)  = bcins_pi(:,:)        ! AIBCM pre-ind
-  m_allaer_pi(:,:,10) = pomins_pi(:,:)       ! AIPOMM pre-ind
+  m_allaer_pi(:,:,id_ASBCM_phy)   = bcsol_pi(:,:)        ! ASBCM pre-ind
+  m_allaer_pi(:,:,id_ASPOMM_phy)  = pomsol_pi(:,:)       ! ASPOMM pre-ind
+  m_allaer_pi(:,:,id_ASSO4M_phy)  = sulfate_pi(:,:)      ! ASSO4M (= SO4) pre-ind
+  m_allaer_pi(:,:,id_CSSO4M_phy)  = 0.                   ! CSSO4M pre-ind
+  m_allaer_pi(:,:,id_SSSSM_phy)   = sssupco_pi(:,:)      ! SSSSM pre-ind
+  m_allaer_pi(:,:,id_ASSSM_phy)   = sscoarse_pi(:,:)     ! CSSSM pre-ind
+  m_allaer_pi(:,:,id_CIDUSTM_phy) = ssacu_pi(:,:)        ! ASSSM pre-ind
+  m_allaer_pi(:,:,id_AIBCM_phy)   = cidust_pi(:,:)       ! CIDUSTM pre-ind
+  m_allaer_pi(:,:,id_AIBCM_phy)   = bcins_pi(:,:)        ! AIBCM pre-ind
+  m_allaer_pi(:,:,id_AIPOMM_phy)  = pomins_pi(:,:)       ! AIPOMM pre-ind
+  m_allaer_pi(:,:,id_ASNO3M_phy) = 0.0
+  m_allaer_pi(:,:,id_CSNO3M_phy) = 0.0
+  m_allaer_pi(:,:,id_CINO3M_phy) = 0.0
 
 !
 ! Calculate the total mass of all soluble aersosols
 !
-  mass_solu_aero(:,:)    = sulfate(:,:)    + bcsol(:,:)    + pomsol(:,:) !   + &
-!       sscoarse(:,:)    + ssacu(:,:)    + sssupco(:,:) 
-  mass_solu_aero_pi(:,:) = sulfate_pi(:,:) + bcsol_pi(:,:) + pomsol_pi(:,:) ! + &
-!       sscoarse_pi(:,:) + ssacu_pi(:,:) + sssupco_pi(:,:)
+  mass_solu_aero(:,:)    = sulfate(:,:)    + bcsol(:,:)    + pomsol(:,:) + ssacu(:,:)
+  mass_solu_aero_pi(:,:) = sulfate_pi(:,:) + bcsol_pi(:,:) + pomsol_pi(:,:) + ssacu_pi(:,:)
 
 !****************************************************************************************
@@ -214,5 +218,5 @@
 ! Diagnostics calculation for CMIP5 protocol
   sconcso4(:)=m_allaer(:,1,id_ASSO4M_phy)*1.e-9
-!  sconcno3(:)=m_allaer(:,1,id_ASNO3M_phy)*1.e-9
+  sconcno3(:)=m_allaer(:,1,id_ASNO3M_phy)*1.e-9
   sconcoa(:)=(m_allaer(:,1,id_ASPOMM_phy)+m_allaer(:,1,id_AIPOMM_phy))*1.e-9
   sconcbc(:)=(m_allaer(:,1,id_ASBCM_phy)+m_allaer(:,1,id_AIBCM_phy))*1.e-9
@@ -220,5 +224,5 @@
   sconcdust(:)=m_allaer(:,1,id_CIDUSTM_phy)*1.e-9
   concso4(:,:)=m_allaer(:,:,id_ASSO4M_phy)*1.e-9
-!  concno3(:,:)=m_allaer(:,:,id_ASNO3M_phy)*1.e-9
+  concno3(:,:)=m_allaer(:,:,id_ASNO3M_phy)*1.e-9
   concoa(:,:)=(m_allaer(:,:,id_ASPOMM_phy)+m_allaer(:,:,id_AIPOMM_phy))*1.e-9
   concbc(:,:)=(m_allaer(:,:,id_ASBCM_phy)+m_allaer(:,:,id_AIBCM_phy))*1.e-9
Index: /LMDZ5/branches/testing/libf/phylmd/readaerosolstrato.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/readaerosolstrato.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/readaerosolstrato.F90	(revision 2408)
@@ -6,5 +6,6 @@
 
     USE phys_cal_mod, ONLY : mth_cur
-    USE mod_grid_phy_lmdz
+    USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat, klon_glo, &
+                                 grid2dto1d_glo
     USE mod_phys_lmdz_mpi_data, ONLY :  is_mpi_root
     USE mod_phys_lmdz_para 
@@ -17,5 +18,4 @@
 
     include "YOMCST.h"
-    include "dimensions.h"
 
 ! Variable input
@@ -85,6 +85,6 @@
     n_lat = size(latitude)
     print *, 'LAT aerosol strato=', n_lat, latitude
-    IF (n_lat.NE.jjm+1) THEN 
-       print *,'Le nombre de lat n est pas egal a jjm+1'
+    IF (n_lat.NE.nbp_lat) THEN 
+       print *,'Le nombre de lat n est pas egal a nbp_lat'
        STOP
     ENDIF
@@ -94,6 +94,6 @@
     n_lon = size(longitude)
     print *, 'LON aerosol strato=', n_lon, longitude
-    IF (n_lon.NE.iim) THEN 
-       print *,'Le nombre de lon n est pas egal a iim'
+    IF (n_lon.NE.nbp_lon) THEN 
+       print *,'Le nombre de lon n est pas egal a nbp_lon'
        STOP
     ENDIF
Index: /LMDZ5/branches/testing/libf/phylmd/readchlorophyll.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/readchlorophyll.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/readchlorophyll.F90	(revision 2408)
@@ -10,15 +10,13 @@
 
     USE phys_cal_mod, ONLY : mth_cur
-    USE mod_grid_phy_lmdz
+    USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat, klon_glo, &
+                                 grid2dto1d_glo
     USE mod_phys_lmdz_mpi_data, ONLY :  is_mpi_root
-    USE mod_phys_lmdz_para 
-    USE phys_state_var_mod
-    USE phys_local_var_mod
-    USE dimphy
+    USE mod_phys_lmdz_para, ONLY: scatter 
+    USE phys_state_var_mod, ONLY: chl_con
 
     implicit none
 
     include "YOMCST.h"
-    include "dimensions.h"
 
 ! Variable input
@@ -62,6 +60,6 @@
     n_lon = size(longitude)
 !    print *, 'LON chlorophyll=', n_lon, longitude
-    IF (n_lon.NE.iim) THEN
-       print *,'Le nombre de lon n est pas egal a iim'
+    IF (n_lon.NE.nbp_lon) THEN
+       print *,'Le nombre de lon n est pas egal a nbp_lon'
        STOP
     ENDIF
@@ -72,6 +70,6 @@
     n_lat = size(latitude)
 !    print *, 'LAT chlorophyll=', n_lat, latitude
-    IF (n_lat.NE.jjm+1) THEN 
-       print *,'Le nombre de lat n est pas egal a jjm+1'
+    IF (n_lat.NE.nbp_lat) THEN 
+       print *,'Le nombre de lat n est pas egal a jnbp_lat'
        STOP
     ENDIF
@@ -93,5 +91,5 @@
     CALL nf95_inq_varid(ncid_in, "CHL", varid)
     ncerr = nf90_get_var(ncid_in, varid, chlorocon)
-    print *,'code erreur readaerosolstrato=', ncerr, varid
+    print *,'code erreur readchlorophyll=', ncerr, varid
 
     CALL nf95_close(ncid_in)
@@ -99,5 +97,5 @@
 !---select the correct month
     IF (mth_cur.LT.1.OR.mth_cur.GT.12) THEN
-      print *,'probleme avec le mois dans readaerosolstrat =', mth_cur
+      print *,'probleme avec le mois dans readchlorophyll =', mth_cur
     ENDIF
     chlorocon_mois(:,:) = chlorocon(:,:,mth_cur)
@@ -109,5 +107,7 @@
     print*,"chrolophyll current month",mth_cur
     do i=1,klon_glo
-      if(isnan(chlorocon_mois_glo(i)))then
+!      if(isnan(chlorocon_mois_glo(i)))then ! isnan() is not in the Fortran standard...
+!      Another way to check for NaN:
+       if(chlorocon_mois_glo(i).ne.chlorocon_mois_glo(i)) then
          chlorocon_mois_glo(i)=0.
       endif
Index: /LMDZ5/branches/testing/libf/phylmd/regr_lat_time_climoz_m.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/regr_lat_time_climoz_m.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/regr_lat_time_climoz_m.F90	(revision 2408)
@@ -66,4 +66,5 @@
     ! year.
 
+    use mod_grid_phy_lmdz, ONLY : nbp_lat
     use regr1_step_av_m, only: regr1_step_av
     use regr3_lint_m, only: regr3_lint
@@ -73,4 +74,6 @@
     use netcdf, only: nf90_get_att, nf90_get_var, nf90_noerr, nf90_nowrite
     use assert_m, only: assert
+    use regular_lonlat_mod, only : boundslat_reg, south
+    use nrtype, only: pi
 
     integer, intent(in):: read_climoz ! read ozone climatology
@@ -81,13 +84,4 @@
 
     ! Variables local to the procedure:
-
-    include "dimensions.h"
-    ! (for "jjm")
-    include "paramet.h"
-    ! (for the other included files)
-    include "comgeom2.h"
-    ! (for "rlatv")
-    include "comconst.h"
-    ! (for "pi")
 
     integer n_plev ! number of pressure levels in the input data
@@ -289,6 +283,6 @@
     call nf95_close(ncid_in)
 
-    allocate(o3_regr_lat(jjm + 1, n_plev, 0:13, read_climoz))
-    allocate(o3_out(jjm + 1, n_plev, 360, read_climoz))
+    allocate(o3_regr_lat(nbp_lat, n_plev, 0:13, read_climoz))
+    allocate(o3_out(nbp_lat, n_plev, 360, read_climoz))
 
     ! Regrid in latitude:
@@ -298,6 +292,6 @@
        print *, &
             "Found 12 months in ozone climatologies, assuming periodicity..."
-       o3_regr_lat(jjm+1:1:-1, :, 1:12, :) = regr1_step_av(o3_in, &
-            xs=sin(lat_in_edg), xt=sin((/- pi / 2, rlatv(jjm:1:-1), pi / 2/)))
+       o3_regr_lat(nbp_lat:1:-1, :, 1:12, :) = regr1_step_av(o3_in, &
+            xs=sin(lat_in_edg), xt=sin((/- pi / 2, boundslat_reg(nbp_lat-1:1:-1,south), pi / 2/)))
        ! (invert order of indices in "o3_regr_lat" because "rlatu" is
        ! in descending order)
@@ -309,6 +303,6 @@
     else
        print *, "Using 14 months in ozone climatologies..."
-       o3_regr_lat(jjm+1:1:-1, :, :, :) = regr1_step_av(o3_in, &
-            xs=sin(lat_in_edg), xt=sin((/- pi / 2, rlatv(jjm:1:-1), pi / 2/)))
+       o3_regr_lat(nbp_lat:1:-1, :, :, :) = regr1_step_av(o3_in, &
+            xs=sin(lat_in_edg), xt=sin((/- pi / 2, boundslat_reg(nbp_lat-1:1:-1,south), pi / 2/)))
        ! (invert order of indices in "o3_regr_lat" because "rlatu" is
        ! in descending order)
@@ -320,5 +314,5 @@
     ! Write to file:
     do m = 1, read_climoz
-       call nf95_put_var(ncid_out, varid_out(m), o3_out(jjm+1:1:-1, :, :, m))
+       call nf95_put_var(ncid_out, varid_out(m), o3_out(nbp_lat:1:-1, :, :, m))
        ! (The order of "rlatu" is inverted in the output file)
     end do
@@ -336,7 +330,10 @@
     ! dimensions and variables, and writes one of the coordinate variables.
 
+    use mod_grid_phy_lmdz, ONLY : nbp_lat
     use netcdf95, only: nf95_create, nf95_def_dim, nf95_def_var, &
          nf95_put_att, nf95_enddef, nf95_copy_att, nf95_put_var
     use netcdf, only: nf90_clobber, nf90_float, nf90_global
+    use nrtype, only: pi
+    use regular_lonlat_mod, only : lat_reg
 
     integer, intent(in):: ncid_in, n_plev
@@ -349,13 +346,4 @@
     ! Variables local to the procedure:
 
-    include "dimensions.h"
-    ! (for "jjm")
-    include "paramet.h"
-    ! (for the other included files)
-    include "comgeom2.h"
-    ! (for "rlatu")
-    include "comconst.h"
-    ! (for "pi")
-
     integer ncerr
     integer dimid_rlatu, dimid_plev, dimid_time
@@ -371,5 +359,5 @@
     call nf95_def_dim(ncid_out, "time", 360, dimid_time)
     call nf95_def_dim(ncid_out, "plev", n_plev, dimid_plev)
-    call nf95_def_dim(ncid_out, "rlatu", jjm + 1, dimid_rlatu)
+    call nf95_def_dim(ncid_out, "rlatu", nbp_lat, dimid_rlatu)
 
     ! Define coordinate variables:
@@ -432,5 +420,5 @@
 
     ! Write one of the coordinate variables:
-    call nf95_put_var(ncid_out, varid_rlatu, rlatu(jjm+1:1:-1) / pi * 180.)
+    call nf95_put_var(ncid_out, varid_rlatu, lat_reg(nbp_lat:1:-1) / pi * 180.)
     ! (convert from rad to degrees and sort in ascending order)
 
Index: /LMDZ5/branches/testing/libf/phylmd/regr_lat_time_coefoz_m.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/regr_lat_time_coefoz_m.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/regr_lat_time_coefoz_m.F90	(revision 2408)
@@ -40,4 +40,5 @@
     ! when we regrid in pressure).
 
+    use mod_grid_phy_lmdz, ONLY : nbp_lat
     use regr1_step_av_m, only: regr1_step_av
     use regr3_lint_m, only: regr3_lint
@@ -45,14 +46,8 @@
          nf95_put_var, nf95_gw_var
     use netcdf, only: nf90_nowrite, nf90_get_var
+    use nrtype, only: pi
+    use regular_lonlat_mod, only: boundslat_reg, south
 
     ! Variables local to the procedure:
-
-    include "dimensions.h"
-    ! (for "jjm")
-    include "paramet.h"
-    include "comgeom2.h"
-    ! (for "rlatv")
-    include "comconst.h"
-    ! (for "pi")
 
     integer ncid_in, ncid_out ! NetCDF IDs for input and output files
@@ -164,5 +159,5 @@
     call nf95_inq_varid(ncid_in, "latitude", varid)
     call nf95_gw_var(ncid_in, varid, latitude)
-    ! Convert from degrees to rad, because "rlatv" is in rad:
+    ! Convert from degrees to rad, because "boundslat_reg" is in rad:
     latitude = latitude / 180. * pi
     n_lat = size(latitude)
@@ -200,6 +195,6 @@
 
     allocate(o3_par_in(n_lat, n_plev, 12))
-    allocate(v_regr_lat(jjm + 1, n_plev, 0:13))
-    allocate(o3_par_out(jjm + 1, n_plev, 360))
+    allocate(v_regr_lat(nbp_lat, n_plev, 0:13))
+    allocate(o3_par_out(nbp_lat, n_plev, 360))
 
     do i_v = 1, n_o3_param
@@ -214,6 +209,6 @@
        ! We average with respect to sine of latitude, which is
        ! equivalent to weighting by cosine of latitude:
-       v_regr_lat(jjm+1:1:-1, :, 1:12) = regr1_step_av(o3_par_in, &
-            xs=sin(lat_in_edg), xt=sin((/- pi / 2, rlatv(jjm:1:-1), pi / 2/)))
+       v_regr_lat(nbp_lat:1:-1, :, 1:12) = regr1_step_av(o3_par_in, &
+            xs=sin(lat_in_edg), xt=sin((/- pi / 2, boundslat_reg(nbp_lat-1:1:-1,south), pi / 2/)))
        ! (invert order of indices in "v_regr_lat" because "rlatu" is
        ! in descending order)
@@ -229,5 +224,5 @@
        ! Write to file:
        call nf95_put_var(ncid_out, varid_out(i_v), &
-            o3_par_out(jjm+1:1:-1, :, :))
+            o3_par_out(nbp_lat:1:-1, :, :))
        ! (The order of "rlatu" is inverted in the output file)
     end do
@@ -246,4 +241,5 @@
     ! dimensions and variables, and writes one of the coordinate variables.
 
+    use mod_grid_phy_lmdz, ONLY : nbp_lat
     use assert_eq_m, only: assert_eq
 
@@ -251,4 +247,6 @@
          nf95_put_att, nf95_enddef, nf95_copy_att, nf95_put_var
     use netcdf, only: nf90_clobber, nf90_float, nf90_copy_att, nf90_global
+    use nrtype, only: pi
+    use regular_lonlat_mod, only : lat_reg
 
     integer, intent(in):: ncid_in, varid_in(:), n_plev
@@ -257,12 +255,4 @@
 
     ! Variables local to the procedure:
-
-    include "dimensions.h"
-    ! (for "jjm")
-    include "paramet.h"
-    include "comgeom2.h"
-    ! (for "rlatu")
-    include "comconst.h"
-    ! (for "pi")
 
     integer ncerr
@@ -282,5 +272,5 @@
     call nf95_def_dim(ncid_out, "time", 360, dimid_time)
     call nf95_def_dim(ncid_out, "plev", n_plev, dimid_plev)
-    call nf95_def_dim(ncid_out, "rlatu", jjm + 1, dimid_rlatu)
+    call nf95_def_dim(ncid_out, "rlatu", nbp_lat, dimid_rlatu)
 
     ! Define coordinate variables:
@@ -332,5 +322,5 @@
 
     ! Write one of the coordinate variables:
-    call nf95_put_var(ncid_out, varid_rlatu, rlatu(jjm+1:1:-1) / pi * 180.)
+    call nf95_put_var(ncid_out, varid_rlatu, lat_reg(nbp_lat:1:-1) / pi * 180.)
     ! (convert from rad to degrees and sort in ascending order)
 
Index: /LMDZ5/branches/testing/libf/phylmd/regr_pr_av_m.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/regr_pr_av_m.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/regr_pr_av_m.F90	(revision 2408)
@@ -40,5 +40,5 @@
     use regr1_step_av_m, only: regr1_step_av
     use mod_phys_lmdz_mpi_data, only: is_mpi_root
-
+    use mod_grid_phy_lmdz, only: nbp_lon, nbp_lat, nbp_lev
     use mod_phys_lmdz_transfert_para, only: scatter2d
     ! (pack to the LMDZ horizontal "physics" grid and scatter)
@@ -63,8 +63,7 @@
     ! Variables local to the procedure:
 
-    include "dimensions.h"
     integer varid, ncerr ! for NetCDF
 
-    real  v1(iim, jjm + 1, size(press_in_edg) - 1, size(name))
+    real  v1(nbp_lon, nbp_lat, size(press_in_edg) - 1, size(name))
     ! input fields at day "julien", on the global "dynamics" horizontal grid
     ! First dimension is for longitude.
@@ -84,7 +83,7 @@
     !--------------------------------------------
 
-    call assert(size(v3, 1) == klon, size(v3, 2) == llm, "regr_pr_av v3 klon")
+    call assert(size(v3, 1) == klon, size(v3, 2) == nbp_lev, "regr_pr_av v3 klon")
     n_var = assert_eq(size(name), size(v3, 3), "regr_pr_av v3 n_var")
-    call assert(shape(paprs) == (/klon, llm+1/), "regr_pr_av paprs")
+    call assert(shape(paprs) == (/klon, nbp_lev+1/), "regr_pr_av paprs")
 
     !$omp master
@@ -102,8 +101,8 @@
        ! Latitudes are in ascending order in the input file while
        ! "rlatu" is in descending order so we need to invert order:
-       v1(1, :, :, :) = v1(1, jjm+1:1:-1, :, :)
+       v1(1, :, :, :) = v1(1, nbp_lat:1:-1, :, :)
 
        ! Duplicate on all longitudes:
-       v1(2:, :, :, :) = spread(v1(1, :, :, :), dim=1, ncopies=iim-1)
+       v1(2:, :, :, :) = spread(v1(1, :, :, :), dim=1, ncopies=nbp_lon-1)
     end if
     !$omp end master
@@ -113,6 +112,6 @@
     ! Regrid in pressure at each horizontal position:
     do i = 1, klon
-       v3(i, llm:1:-1, :) = regr1_step_av(v2(i, :, :), press_in_edg, &
-            paprs(i, llm+1:1:-1))
+       v3(i, nbp_lev:1:-1, :) = regr1_step_av(v2(i, :, :), press_in_edg, &
+            paprs(i, nbp_lev+1:1:-1))
        ! (invert order of indices because "paprs" is in descending order)
     end do
Index: /LMDZ5/branches/testing/libf/phylmd/regr_pr_comb_coefoz_m.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/regr_pr_comb_coefoz_m.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/regr_pr_comb_coefoz_m.F90	(revision 2408)
@@ -40,7 +40,7 @@
 
     use dimphy, only: klon
+    use mod_grid_phy_lmdz, only: nbp_lev
 
     ! Variables local to the procedure:
-    include "dimensions.h"
 
     !---------------------------------------
@@ -49,6 +49,6 @@
     print *, "Call sequence information: alloc_coefoz"
     !$omp end master
-    allocate(c_Mob(klon, llm), a2(klon, llm), a4_mass(klon, llm))
-    allocate(a6_mass(klon, llm), r_het_interm(klon, llm))
+    allocate(c_Mob(klon, nbp_lev), a2(klon, nbp_lev), a4_mass(klon, nbp_lev))
+    allocate(a6_mass(klon, nbp_lev), r_het_interm(klon, nbp_lev))
 
   end subroutine alloc_coefoz
@@ -79,4 +79,5 @@
     use regr_pr_int_m, only: regr_pr_int
     use press_coefoz_m, only: press_in_edg, plev
+    use mod_grid_phy_lmdz, only: nbp_lev
 
     integer, intent(in):: julien ! jour julien, 1 <= julien <= 360
@@ -85,16 +86,15 @@
     ! (latitude on the partial "physics" grid, in degrees)
 
-    real, intent(in):: paprs(:, :) ! (klon, llm + 1)
+    real, intent(in):: paprs(:, :) ! (klon, nbp_lev + 1)
     ! (pression pour chaque inter-couche, en Pa)
 
-    real, intent(in):: pplay(:, :) ! (klon, llm)
+    real, intent(in):: pplay(:, :) ! (klon, nbp_lev)
     ! (pression pour le mileu de chaque couche, en Pa)
 
     ! Variables local to the procedure:
 
-    include "dimensions.h"
     integer ncid ! for NetCDF
 
-    real coefoz(klon, llm, 7)
+    real coefoz(klon, nbp_lev, 7)
     ! (temporary storage for 7 ozone coefficients)
     ! (On the partial "physics" grid.
@@ -102,5 +102,5 @@
     ! middle of layer "k".)
 
-    real a6(klon, llm)
+    real a6(klon, nbp_lev)
     ! (derivative of "P_net_Mob" with respect to column-density of ozone
     ! above, in cm2 s-1)
@@ -121,6 +121,6 @@
     call assert((/size(rlat), size(paprs, 1), size(pplay, 1)/) == klon, &
          "regr_pr_comb_coefoz klon")
-    call assert((/size(paprs, 2) - 1, size(pplay, 2)/) == llm, &
-         "regr_pr_comb_coefoz llm")
+    call assert((/size(paprs, 2) - 1, size(pplay, 2)/) == nbp_lev, &
+         "regr_pr_comb_coefoz nbp_lev")
 
     !$omp master
@@ -150,5 +150,5 @@
     r_het_interm = coefoz(:, :, 7)
     ! Heterogeneous chemistry is only at high latitudes:
-    forall (k = 1: llm)
+    forall (k = 1: nbp_lev)
        where (abs(rlat) <= 45.) r_het_interm(:, k) = 0.
     end forall
Index: /LMDZ5/branches/testing/libf/phylmd/regr_pr_int_m.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/regr_pr_int_m.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/regr_pr_int_m.F90	(revision 2408)
@@ -30,5 +30,5 @@
     use regr1_lint_m, only: regr1_lint
     use mod_phys_lmdz_mpi_data, only: is_mpi_root
-
+    use mod_grid_phy_lmdz, only: nbp_lon, nbp_lat, nbp_lev
     use mod_phys_lmdz_transfert_para, only: scatter2d
     ! (pack to the LMDZ horizontal "physics" grid and scatter)
@@ -41,5 +41,5 @@
     ! (pressure level of input data, in Pa, in strictly ascending order)
 
-    real, intent(in):: pplay(:, :) ! (klon, llm)
+    real, intent(in):: pplay(:, :) ! (klon, nbp_lev)
     ! (pression pour le mileu de chaque couche, en Pa)
 
@@ -47,5 +47,5 @@
     ! (extra value of field at 0 pressure)
 
-    real, intent(out):: v3(:, :) ! (klon, llm)
+    real, intent(out):: v3(:, :) ! (klon, nbp_lev)
     ! (regridded field on the partial "physics" grid)
     ! ("v3(i, k)" is at longitude "xlon(i)", latitude
@@ -54,8 +54,7 @@
     ! Variables local to the procedure:
 
-    include "dimensions.h"
     integer varid, ncerr ! for NetCDF
 
-    real  v1(iim, jjm + 1, 0:size(plev))
+    real  v1(nbp_lon, nbp_lat, 0:size(plev))
     ! (input field at day "julien", on the global "dynamics" horizontal grid)
     ! (First dimension is for longitude.
@@ -72,6 +71,6 @@
     !--------------------------------------------
 
-    call assert(shape(v3) == (/klon, llm/), "regr_pr_int v3")
-    call assert(shape(pplay) == (/klon, llm/), "regr_pr_int pplay")
+    call assert(shape(v3) == (/klon, nbp_lev/), "regr_pr_int v3")
+    call assert(shape(pplay) == (/klon, nbp_lev/), "regr_pr_int pplay")
 
     !$omp master
@@ -84,5 +83,5 @@
        ! Latitudes are in ascending order in the input file while
        ! "rlatu" is in descending order so we need to invert order:
-       v1(1, :, 1:) = v1(1, jjm+1:1:-1, 1:)
+       v1(1, :, 1:) = v1(1, nbp_lat:1:-1, 1:)
 
        ! Complete "v1" with the value at 0 pressure:
@@ -90,5 +89,5 @@
 
        ! Duplicate on all longitudes:
-       v1(2:, :, :) = spread(v1(1, :, :), dim=1, ncopies=iim-1)
+       v1(2:, :, :) = spread(v1(1, :, :), dim=1, ncopies=nbp_lon-1)
     end if
     !$omp end master
@@ -98,5 +97,5 @@
     ! Regrid in pressure at each horizontal position:
     do i = 1, klon
-       v3(i, llm:1:-1) = regr1_lint(v2(i, :), (/0., plev/), pplay(i, llm:1:-1))
+       v3(i, nbp_lev:1:-1) = regr1_lint(v2(i, :), (/0., plev/), pplay(i, nbp_lev:1:-1))
        ! (invert order of indices because "pplay" is in descending order)
     end do
Index: /LMDZ5/branches/testing/libf/phylmd/regr_pr_o3_m.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/regr_pr_o3_m.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/regr_pr_o3_m.F90	(revision 2408)
@@ -30,5 +30,6 @@
     use regr1_step_av_m, only: regr1_step_av
     use press_coefoz_m, only: press_in_edg
-    use control_mod, only: dayref
+    use time_phylmdz_mod, only: day_ref
+    use mod_grid_phy_lmdz, only: nbp_lon, nbp_lat, nbp_lev
 
     REAL, intent(in):: p3d(:, :, :) ! pressure at layer interfaces, in Pa
@@ -43,11 +44,9 @@
     ! Variables local to the procedure:
 
-    include "dimensions.h"
-
     integer ncid, varid, ncerr ! for NetCDF
     integer i, j
 
-    real r_mob(jjm + 1, size(press_in_edg) - 1)
-    ! (ozone mole fraction from Mobidic at day "dayref")
+    real r_mob(nbp_lat, size(press_in_edg) - 1)
+    ! (ozone mole fraction from Mobidic at day "day_ref")
     ! (r_mob(j, k) is at latitude "rlatu(j)", in pressure interval
     ! "[press_in_edg(k), press_in_edg(k+1)]".)
@@ -56,7 +55,7 @@
 
     print *, "Call sequence information: regr_pr_o3"
-    call assert(shape(o3_mob_regr) == (/iim + 1, jjm + 1, llm/), &
+    call assert(shape(o3_mob_regr) == (/nbp_lon + 1, nbp_lat, nbp_lev/), &
          "regr_pr_o3 o3_mob_regr")
-    call assert(shape(p3d) == (/iim + 1, jjm + 1, llm + 1/), "regr_pr_o3 p3d")
+    call assert(shape(p3d) == (/nbp_lon + 1, nbp_lat, nbp_lev + 1/), "regr_pr_o3 p3d")
 
     call nf95_open("coefoz_LMDZ.nc", nf90_nowrite, ncid)
@@ -64,9 +63,9 @@
     call nf95_inq_varid(ncid, "r_Mob", varid)
     ! Get data at the right day from the input file:
-    ncerr = nf90_get_var(ncid, varid, r_mob, start=(/1, 1, dayref/))
+    ncerr = nf90_get_var(ncid, varid, r_mob, start=(/1, 1, day_ref/))
     call handle_err("nf90_get_var r_Mob", ncerr)
     ! Latitudes are in ascending order in the input file while
     ! "rlatu" is in descending order so we need to invert order:
-    r_mob = r_mob(jjm+1:1:-1, :)
+    r_mob = r_mob(nbp_lat:1:-1, :)
 
     call nf95_close(ncid)
@@ -75,16 +74,16 @@
 
     ! Poles:
-    do j = 1, jjm + 1, jjm
-       o3_mob_regr(1, j, llm:1:-1) &
-            = regr1_step_av(r_mob(j, :), press_in_edg, p3d(1, j, llm+1:1:-1))
+    do j = 1, nbp_lat, nbp_lat-1
+       o3_mob_regr(1, j, nbp_lev:1:-1) &
+            = regr1_step_av(r_mob(j, :), press_in_edg, p3d(1, j, nbp_lev+1:1:-1))
        ! (invert order of indices because "p3d" is in descending order)
     end do
 
     ! Other latitudes:
-    do j = 2, jjm
-       do i = 1, iim
-          o3_mob_regr(i, j, llm:1:-1) &
+    do j = 2, nbp_lat-1
+       do i = 1, nbp_lon
+          o3_mob_regr(i, j, nbp_lev:1:-1) &
                = regr1_step_av(r_mob(j, :), press_in_edg, &
-               p3d(i, j, llm+1:1:-1))
+               p3d(i, j, nbp_lev+1:1:-1))
              ! (invert order of indices because "p3d" is in descending order)
        end do
@@ -92,10 +91,10 @@
 
     ! Duplicate pole values on all longitudes:
-    o3_mob_regr(2:, 1, :) = spread(o3_mob_regr(1, 1, :), dim=1, ncopies=iim)
-    o3_mob_regr(2:, jjm + 1, :) &
-         = spread(o3_mob_regr(1, jjm + 1, :), dim=1, ncopies=iim)
+    o3_mob_regr(2:, 1, :) = spread(o3_mob_regr(1, 1, :), dim=1, ncopies=nbp_lon)
+    o3_mob_regr(2:, nbp_lat, :) &
+         = spread(o3_mob_regr(1, nbp_lat, :), dim=1, ncopies=nbp_lon)
 
     ! Duplicate first longitude to last longitude:
-    o3_mob_regr(iim + 1, 2:jjm, :) = o3_mob_regr(1, 2:jjm, :)
+    o3_mob_regr(nbp_lon + 1, 2:nbp_lat-1, :) = o3_mob_regr(1, 2:nbp_lat-1, :)
 
   end subroutine regr_pr_o3
Index: /LMDZ5/branches/testing/libf/phylmd/rrtm/aeropt_6bands_rrtm.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/rrtm/aeropt_6bands_rrtm.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/rrtm/aeropt_6bands_rrtm.F90	(revision 2408)
@@ -22,5 +22,4 @@
 
   INCLUDE "YOMCST.h"
-  INCLUDE "iniprint.h"
   INCLUDE "clesphys.h"
 
Index: /LMDZ5/branches/testing/libf/phylmd/rrtm/readaerosol_optic_rrtm.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/rrtm/readaerosol_optic_rrtm.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/rrtm/readaerosol_optic_rrtm.F90	(revision 2408)
@@ -288,8 +288,6 @@
   ! Calculate the total mass of all soluble aersosols
   ! to be revisited for AR6
-  mass_solu_aero(:,:)    = sulfacc(:,:)    + bcsol(:,:)    + pomsol(:,:)   + nitracc(:,:)   ! + & 
-  !                           sscoarse(:,:)    + ssacu(:,:)    + sssupco(:,:) 
-  mass_solu_aero_pi(:,:) = sulfacc_pi(:,:) + bcsol_pi(:,:) + pomsol_pi(:,:) + nitracc_pi(:,:) ! + &
-  !                           sscoarse_pi(:,:) + ssacu_pi(:,:) + sssupco_pi(:,:)
+  mass_solu_aero(:,:)    = sulfacc(:,:)    + bcsol(:,:)    + pomsol(:,:)   + nitracc(:,:) + ssacu(:,:)
+  mass_solu_aero_pi(:,:) = sulfacc_pi(:,:) + bcsol_pi(:,:) + pomsol_pi(:,:) + nitracc_pi(:,:) + ssacu_pi(:,:) 
 
   !****************************************************************************************
@@ -303,4 +301,5 @@
   END DO
 
+!--new aerosol properties
   ! aeropt_6bands for rrtm
   CALL aeropt_6bands_rrtm( &
Index: /LMDZ5/branches/testing/libf/phylmd/rrtm/readaerosolstrato_rrtm.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/rrtm/readaerosolstrato_rrtm.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/rrtm/readaerosolstrato_rrtm.F90	(revision 2408)
@@ -9,5 +9,5 @@
 
     USE phys_cal_mod, ONLY : mth_cur
-    USE mod_grid_phy_lmdz
+    USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat, klon_glo, grid2dTo1d_glo
     USE mod_phys_lmdz_mpi_data, ONLY :  is_mpi_root
     USE mod_phys_lmdz_para 
@@ -21,5 +21,4 @@
 
     include "YOMCST.h"
-    include "dimensions.h"
 
 ! Variable input
@@ -103,6 +102,6 @@
     n_lat = size(latitude)
     print *, 'LAT aerosol strato=', n_lat, latitude
-    IF (n_lat.NE.jjm+1) THEN 
-       print *,'Le nombre de lat n est pas egal a jjm+1'
+    IF (n_lat.NE.nbp_lat) THEN 
+       print *,'Le nombre de lat n est pas egal a nbp_lat'
        STOP
     ENDIF
@@ -112,6 +111,6 @@
     n_lon = size(longitude)
     print *, 'LON aerosol strato=', n_lon, longitude
-    IF (n_lon.NE.iim) THEN 
-       print *,'Le nombre de lon n est pas egal a iim'
+    IF (n_lon.NE.nbp_lon) THEN 
+       print *,'Le nombre de lon n est pas egal a nbp_lon'
        STOP
     ENDIF
Index: /LMDZ5/branches/testing/libf/phylmd/rrtm/rrtm_rtrn1a_140gp.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/rrtm/rrtm_rtrn1a_140gp.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/rrtm/rrtm_rtrn1a_140gp.F90	(revision 2408)
@@ -496,5 +496,5 @@
 !    Z_FACCMB2D(I_LEV-1) = Z_FACCLD1D(I_LEV-1) * Z_FACCLR2D(I_LEV) *&
 !     & (1.0_JPRB - Z_CLDFRAC(I_LEV+1))  
-    if (istcldd(i_lev).ne.1) then
+    if (istcldd(i_lev).ne.1.and.i_lev.ne.0) then
        z_faccmb1d(i_lev-1) = max(0.,min(z_cldfrac(i_lev+1)-z_cldfrac(i_lev), &
                             z_cldfrac(i_lev-1)-z_cldfrac(i_lev)))
Index: /LMDZ5/branches/testing/libf/phylmd/rrtm/suphec.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/rrtm/suphec.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/rrtm/suphec.F90	(revision 2408)
@@ -87,4 +87,5 @@
 USE YOM_PHYS_GRID ,ONLY : PHYS_GRID
 USE YOMCT0  , ONLY  : LSCMEC   ,LROUGH   ,REXTZ0M  ,REXTZ0H
+USE vertical_layers_mod, ONLY: ap,bp
 
 IMPLICIT NONE
@@ -114,6 +115,4 @@
 #include "suvdfs.intfb.h"
 #include "suwcou.intfb.h"
-#include "dimensions.h"
-#include "comvert.h"
 
 !     ------------------------------------------------------------------
@@ -168,6 +167,4 @@
 !ALLOCATE(VBH    (0:MAX(JPMXLE,NFLEVG)))  from suallo.F90
 !! 
-!! ATTENTION, il faut que ~dyn3d/comvert.h soit conforme au Fortran 90 !!
-!! 
 ALLOCATE(VAH    (0:NFLEVG))  ! Ajout ALLOCATE MPL 200509
 ALLOCATE(VBH    (0:NFLEVG))
@@ -177,5 +174,5 @@
 VP00=101325.     !!!!! A REVOIR (MPL)
 ZPRES(NFLEVG)=VP00
-! on recupere ap et bp de dyn3d (comvert.h) MPL 19.05.09
+! on recupere ap et bp de dyn3d (vertical_layers_mod) MPL 19.05.09
 ! Attention, VAH et VBH sont inverses, comme les niveaux
 ! plev(l)=PAPRS(klon,nlayer+1-l) de 1 a nlayer (apllmd.F)
